require 'date'
#~ Idee: Analysieren aus Wiki.
#~ In || sind einzelne Spalten.

#~ Hier werden gesetzliche '''Feiertage in Deutschland''' aufgelistet, die nicht zwangslufig auf einen Sonntag fallen:
#~ {| border="0" bgcolor="#DDDDFF" cellspacing="2"
#~ |----- align="center" valign="top"
#~ ! Feiertag
#~ ! Datum
#~ ! BW
#~ ! BY
#~ ! BE
#~ ! BB
#~ ! HB
#~ ! HH
#~ ! HE
#~ ! MV
#~ ! NI
#~ ! NW
#~ ! RP
#~ ! SL
#~ ! SN
#~ ! ST
#~ ! SH
#~ ! TH
#~ |----- align="center" bgcolor="#F8F8FF"
#~ | [[Neujahr|Neujahrstag]] || [[1. Januar]]
#~ | X || X || X || X || X || X || X || X || X || X || X || X
#~ | X || X || X || X
#~ |----- align="center" bgcolor="#F8F8FF"
#~ | [[Dreiknigsfest|Heilige Drei Knige]]
#~ | [[6. Januar]] || X || X || &nbsp; || &nbsp;
#~ | &nbsp; || &nbsp; || &nbsp;
#~ | &nbsp; || &nbsp; || &nbsp; || &nbsp;
#~ | &nbsp; || &nbsp; || X || &nbsp; || &nbsp;
#~ |----- align="center" bgcolor="#F8F8FF"
#~ | [[Karfreitag]] || [[bewegliche Feiertage|beweglich]]
#~ | X || X || X || X || X || X || X || X || X || X || X || X
#~ | X || X || X || X
#~ |----- align="center" bgcolor="#F8F8FF"
#~ | [[Ostern|Ostermontag]] || [[bewegliche Feiertage|beweglich]]
#~ | X || X || X || X || X || X || X || X || X || X || X || X
#~ | X || X || X || X
#~ |----- align="center" bgcolor="#F8F8FF"
#~ | [[Erster Mai]] || [[1. Mai]] || X || X || X
#~ | X || X || X || X || X || X || X || X || X
#~ | X || X || X || X
#~ |----- align="center" bgcolor="#F8F8FF"
#~ | [[Christi Himmelfahrt]] || [[bewegliche Feiertage|beweglich]]
#~ | X || X || X || X || X || X || X || X || X || X || X || X
#~ | X || X || X || X
#~ |----- align="center" bgcolor="#F8F8FF"
#~ | [[Pfingsten|Pfingstmontag]] || [[bewegliche Feiertage|beweglich]]
#~ | X || X || X || X || X || X || X || X || X || X || X || X
#~ | X || X || X || X
#~ |----- align="center" bgcolor="#F8F8FF"
#~ | [[Fronleichnam]] || [[bewegliche Feiertage|beweglich]]
#~ | X || X || &nbsp; || &nbsp; || &nbsp; || &nbsp; || X
#~ | &nbsp; || &nbsp; || X || X || X || 1) || &nbsp; || &nbsp; || 2)
#~ |----- align="center" bgcolor="#F8F8FF"
#~ | [[Augsburger Friedensfest]]
#~ | [[8. August]] || &nbsp; || 3) || &nbsp; || &nbsp;
#~ | &nbsp; || &nbsp; || &nbsp;
#~ | &nbsp; || &nbsp; || &nbsp; || &nbsp;
#~ | &nbsp; || &nbsp; || &nbsp; || &nbsp; || &nbsp;
#~ |----- align="center" bgcolor="#F8F8FF"
#~ | [[Mari Himmelfahrt]] || [[15. August]]
#~ | &nbsp; || 5) || &nbsp; || &nbsp; || &nbsp; || &nbsp; || &nbsp;
#~ | &nbsp; || &nbsp; || &nbsp; || &nbsp; || X
#~ | &nbsp; || &nbsp; || &nbsp; || &nbsp;
#~ |----- align="center" bgcolor="#F8F8FF"
#~ | [[Tag der Deutschen Einheit]] || [[3. Oktober]]
#~ | X || X || X || X || X || X || X || X || X || X || X || X
#~ | X || X || X || X
#~ |----- align="center" bgcolor="#F8F8FF"
#~ | [[Reformationstag]] || [[31. Oktober]]
#~ | &nbsp; || &nbsp; || &nbsp; || X || &nbsp; || &nbsp; || &nbsp;
#~ | X || &nbsp; || &nbsp; || &nbsp; || &nbsp;
#~ | X || X || &nbsp; || X
#~ |----- align="center" bgcolor="#F8F8FF"
#~ | [[Allerheiligen]] || [[1. November]]
#~ | X || X || &nbsp; || &nbsp; || &nbsp; || &nbsp; || &nbsp;
#~ | &nbsp; || &nbsp; || X || X || X
#~ | &nbsp; || &nbsp; || &nbsp; || &nbsp;
#~ |----- align="center" bgcolor="#F8F8FF"
#~ | [[Bu- und Bettag]] || [[bewegliche Feiertage|beweglich]] || &nbsp; || &nbsp; || &nbsp;
#~ | &nbsp; || &nbsp; || &nbsp;
#~ | &nbsp; || &nbsp; || &nbsp; || &nbsp;
#~ | &nbsp; || &nbsp; || 4) || &nbsp; || &nbsp; || &nbsp;
#~ |----- align="center" bgcolor="#F8F8FF"
#~ | [[Weihnachten|1. Weihnachtstag]] || [[25. Dezember]]
#~ | X || X || X || X || X || X || X || X || X || X || X || X
#~ | X || X || X || X
#~ |----- align="center" bgcolor="#F8F8FF"
#~ | [[Weihnachten|2. Weihnachtstag]] || [[26. Dezember]]
#~ | X || X || X || X || X || X || X || X || X || X || X || X
#~ | X || X || X || X
#~ |}

class Date

	DE_DAYNAMES		=	[ 'Sonntag', 'Montag', 'Dienstag', 'Mittwoch', 'Donnerstag', 'Freitag', 'Samstag' ]
	DE_ABBR_DAYNAMES	=	[ 'So', 'Mo', 'Di', 'Mi', 'Do', 'Fr', 'Sa' ]
	DE_MONTHNAMES	= 	[nil, 'Januar', 'Februar', 'Mrz', 'April', 'Mai', 'Juni', 'Juli', 'August', 'September', 'Oktober', 'November', 'Dezember']
	DE_ABBR_MONTHNAMES= [nil, 'Jan', 'Feb', 'Mrz', 'April', 'Mai', 'Juni', 'Juli', 'Aug', 'Sep', 'Okt', 'Nov', 'Dez']

	#~ Date::DAYNAMES		= Date::DE_DAYNAMES
	#~ Date::ABBR_DAYNAMES	= Date::DE_ABBR_DAYNAMES
	#~ Date::MONTHNAMES		= Date::DE_MONTHNAMES
	#~ Date::ABBR_MONTHNAMES= Date::DE_ABBR_MONTHNAMES

	#~ DAYNAMES		= DE_DAYNAMES
	#~ ABBR_DAYNAMES	= DE_ABBR_DAYNAMES
	#~ MONTHNAMES		= DE_MONTHNAMES
	#~ ABBR_MONTHNAMES	= DE_ABBR_MONTHNAMES
	def strftime_d( key )
		res = self.strftime( key )
		res.gsub!(/Monday/, 'Montag')
		res.gsub!(/Tuesday/, 'Dienstag')
		res.gsub!(/Wednesday/, 'Mittwoch')
		res.gsub!(/Thursday/, 'Donnerstag')
		res.gsub!(/Fryday/, 'Freitag')
		res.gsub!(/Saturday/, 'Samstag')
		res.gsub!(/Sunday/, 'Sonntag')
		res.gsub!(/January/, 'Januar')
		res.gsub!(/February/, 'Februar')
		res.gsub!(/March/, 'Mrz')
		res.gsub!(/May/, 'Mai')
		res.gsub!(/June/, 'Juni')
		res.gsub!(/July/, 'Juli')
		res.gsub!(/October/, 'Oktober')
		res.gsub!(/December/, 'Dezember')
		return res
	end
	
	#http://de.wikipedia.org/wiki/HOLIDAY_(Deutschland)
	HOLIDAY = {
		:german => { 
				'1-1' => 'Neujahr',
				'1-6' => 'Hl. 3 Knige',
				'5-1' => '1.Mai',
				#~ '1-5' => 'Augsburger Friedensfest',
				'10-3' => 'Tag der deutschen Einheit',
				#~ '10-31' => 'Reformationstag',
				'11-1' => 'Allerheiligen',
				'12-24' => 'Heilig Abend',
				'12-25' => 'Weihnachten',
				'12-26' => 'Weihnachten',
		}
	}
	HOLIDAY[:bawue]= HOLIDAY[:german]
	HOLIDAY[:niedersachsen]	= HOLIDAY[:german]
	HOLIDAY[:by]	= {'8-15' => 'Mari Himmelfahrt'}.update(HOLIDAY[:german])
	
	#http://de.wikipedia.org/wiki/Schulferien enthlt nur Sommerferien.
	#http://www.schulferien.org/Baden-Wurttemb_/baden-wurttemb_.html
	SCHOOLHOLIDAY = {
		:bawue => [
			[ Date.new( 2004, 7, 4),	Date.new( 2004, 9, 11 ) ],
			[ Date.new( 2004, 11, 2),	Date.new( 2004, 11, 6 ) ],
			[ Date.new( 2004, 12, 23),	Date.new( 2005, 1, 8 ) ],
			[ Date.new( 2005,  3, 24),		Date.new( 2005, 4, 2 ) ],
			[ Date.new( 2005,  5, 17),		Date.new( 2005, 5,28 ) ],
			[ Date.new( 2005,  7, 28),		Date.new( 2005, 9,10 ) ],
			[ Date.new( 2005, 10, 31),	Date.new( 2005,11, 4 ) ],
			[ Date.new( 2005, 12, 22),	Date.new( 2006, 1,5 ) ],
			[ Date.new( 2006, 3, 29),	Date.new( 2006, 4,2 ) ], #13.4.
			[ Date.new( 2006, 5, 29),	Date.new( 2006, 6,10 ) ], 
			[ Date.new( 2006, 8, 3),	Date.new( 2006, 9,16 ) ], 
			],
		:niedersachsen => [
			[ Date.new( 2004, 8, 1),	Date.new( 2004, 8, 18 ) ],
			[ Date.new( 2004,  10, 11),		Date.new( 2004, 10, 22 ) ],
			[ Date.new( 2004,  12, 23),		Date.new( 2005, 1, 7 ) ],
			[ Date.new( 2005,  3, 17),		Date.new( 2005, 4, 1 ) ],
			[ Date.new( 2005, 5, 5),	Date.new( 2005, 5, 6 ) ],
			[ Date.new( 2005, 5, 25),	Date.new( 2005, 5, 27 ) ],
			[ Date.new( 2005, 7, 14),	Date.new( 2005, 8, 24 ) ],
		]
	}

#Based on holiday.rb: Written by Tadayoshi Funaba 1998-2003
	def self.julian_easter(y, sg=ITALY)
		a = y % 4
		b = y % 7
		c = y % 19
		d = (19 * c + 15) % 30
		e = (2 * a + 4 * b - d + 34) % 7
		f, g = (d + e + 114).divmod(31)
		jd = civil_to_jd(y, f, g + 1, JULIAN)
		new0(jd, 0, sg)
	end

#Based on holiday.rb: Written by Tadayoshi Funaba 1998-2003
	def self.gregorian_easter(y, sg=ITALY)
		a = y % 19
		b, c = y.divmod(100)
		d, e = b.divmod(4)
		f = ((b + 8) / 25).to_i
		g = ((b - f + 1) / 3).to_i
		h = (19 * a + b - d - g + 15) % 30
		i, k = c.divmod(4)
		l = (32 + 2 * e + 2 * i - h - k) % 7
		m = ((a + 11 * h + 22 * l) / 451).to_i
		n, p = (h + l - 7 * m + 114).divmod(31)
		jd = civil_to_jd(y, n, p + 1, GREGORIAN)
		new0(jd, 0, sg)
	end

	class << self; alias_method :easter, :gregorian_easter end
	
	def easter?
		self ===
		(if os?
			self.class.julian_easter(year)
		else
			self.class.gregorian_easter(year)
		end)
	end
	#Test for sundays
	def sun?
		self.wday == 0
	end
	
	#Siehe
	#-http://de.wikipedia.org/wiki/Bewegliche_HOLIDAY
	def holiday( holidays = HOLIDAY[:bawue] )
		holidays = HOLIDAY[ holidays ] if holidays.kind_of?( Symbol )
		if @holiday == nil
			@holiday = holidays["#{self.month}-#{self.day}"]
			if self.easter?
				@holiday = 'Ostersonntag'
			elsif (self - 1).easter?
				@holiday = 'Ostermontag'
			#~ elsif (self + 47).easter?
				#~ @holiday = 'Fastnacht'	#Kein Feiertag
			elsif (self + 2).easter?
				@holiday = 'Karfreitag'
			elsif (self - 39).easter?
				@holiday = 'Christi Himmelfahrt'
			elsif (self - 49).easter?
				@holiday = 'Pfingsten'
			elsif (self - 50).easter?
				@holiday = 'Pfingsten'
			elsif (self - 60).easter?
				@holiday = 'Fronleichnam'
			end
			@holiday = '' if @holiday == nil
		end
		return @holiday
	end
	def holiday?( holidays = :bawue )
		return self.holiday( holidays ) != ''
	end
	#Prfung auf Schulferien.
	def schoolholiday?( ferien = SCHOOLHOLIDAY[:bawue] )
		ferien = SCHOOLHOLIDAY[ ferien ] if ferien.kind_of?( Symbol )
		#~ if @holiday 
		if holiday? 
			return @holiday 
		else	#Check holiday
			ferien.each{|f|
				return true if self.between?( f[0], f[1] )
			}
			return nil
		end
	end

end

if __FILE__ == $0
Date.new( 2005,1,1 ).upto( Date.new( 2005,12,31 ) ){|d|
	#~ puts "#{d} Ostern"	if d.easter?
	#~ puts "#{d} Sonntag"	if d.sun?
	puts "#{d} Feiertag (#{d.holiday})"	if d.holiday?
	#~ puts "#{d} Ferien"				if d.schoolholiday?
}
end


